from collections import deque, defaultdict

def find_guard_w(n, m, k, roads, guards):
    graph = defaultdict(list)
    for a, b in roads:
        graph[a].append(b)
        graph[b].append(a)
    guard_w = set()

    for p, h in guards:
        queue = deque([(p, 0)])
        visited = set([p])

        while queue:
            cur_w, distance = queue.popleft()
            guard_w .add(cur_w)

            if distance < h:
                for neighbor in graph[cur_w]:
                    if neighbor not in visited:
                        visited.add(neighbor)
                        queue.append((neighbor, distance + 1))

    guard_w  = sorted(guard_w )
    return len(guard_w ), guard_w


n, m, k = map(int, input().split())
roads = [tuple(map(int, input().split())) for _ in range(m)]
guards = [tuple(map(int, input().split())) for _ in range(k)]

count, warehouses = find_guard_w(n, m, k, roads, guards)

print(count)
if count > 0:
    print(" ".join(map(str, warehouses)))
else:
    print()